const int ROWS[] = {6,7,8,9};
const int COLS[] = {5,4,3,2};
const int NUM_ROWS = sizeof(ROWS)/sizeof(int);
const int NUM_COLS = sizeof(COLS)/sizeof(int);

const char KEYS[NUM_ROWS][NUM_COLS] = {
  {'A', 'B', 'C', 'D'},
  {'E', 'F', 'G', 'H'},
  {'I', 'J', 'K', 'L'},
  {'M', 'N', 'O', 'P'}
};

void setup() {
  Serial.begin(9600);
  for(int x = 0; x < NUM_ROWS; x++) {
    pinMode(ROWS[x], OUTPUT);
    digitalWrite(ROWS[x], LOW);
  }

  for(int x = 0; x < NUM_COLS; x++) {
    pinMode(COLS[x], INPUT_PULLUP);
  }
  
  Serial.println("Keypad initialized");
  printKeypadLayout();
}

void loop() {
  char key = readKey();
  if(key) Serial.println(key);
}

void printKeypadLayout() {
  for(int x = 0; x < NUM_ROWS; x++) {
    for(int y = 0; y < NUM_COLS; y++) {
      Serial.print(KEYS[x][y]);
      Serial.print("\t");
    }
    Serial.print("\n");
  }
  Serial.print("\n");
}

char readKey() {
  for(int x = 0; x < NUM_ROWS; x++) {
    for(int row = 0; row < NUM_ROWS; row++) digitalWrite(ROWS[row], x != row);
    for(int y = 0; y < NUM_COLS; y++) {
      if(!digitalRead(COLS[y])) return KEYS[x][y];
    }
  }
  return 0;
}

